//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#include <tigcclib.h>

//-----------------------------------------------------------------------------

void Column_Make_First(void);
void Column_Extract_MaskData(int c, unsigned short *src, unsigned short *dest);
void Column_Display(int c, unsigned short *src);
void Column_Make(unsigned short *src, unsigned short *mask, unsigned short *dest);
void Screen_Make(void);


//-----------------------------------------------------------------------------

extern unsigned short Mask_Data[1000];
extern unsigned short Tiles_Data[200];

//-----------------------------------------------------------------------------

char *Plane0;
char *Plane1;

unsigned short*col_src;
unsigned short*col_mask;
unsigned short*col_dest;

int shift_count=2;

int source_mode=0;

//-----------------------------------------------------------------------------

void Column_Make_First(void)
{
	
	if (!source_mode)
	{
		int a;
		char*ptr=(char*)col_src;
		for (a=0;a<4*100;a++)
		*ptr++=random(255);
	}
	else
	memcpy(col_src,Tiles_Data,4*100);
	
}
//-----------------------------------------------------------------------------

// MaskData Format : 160*100
void Column_Extract_MaskData(int c, unsigned short *src, unsigned short *dest)
{
	src+=c;
	
	int a;
	for (a=0;a<100;a++,src+=10,dest++)
	{
		*dest=*src;
		*(dest+100)=*src;
	}
	
}
//-----------------------------------------------------------------------------

void Column_Display(int c, unsigned short *src)
{
	unsigned short* dest0 = (unsigned short*) Plane0+c;
	unsigned short* dest1 = (unsigned short*) Plane1+c;
	
	int a;
	for (a=0;a<100;a++,dest0+=15)
	*dest0=*src++;
	for (a=0;a<100;a++,dest1+=15)
	*dest1=*src++;
	
}
//-----------------------------------------------------------------------------

void Column_Make(unsigned short *src, unsigned short *mask, unsigned short *dest)
{
	unsigned short src1;
	unsigned short src2;
	//unsigned short mask2=((1<<shift_count)-1);
	unsigned short mask2=((1<<(16-shift_count))-1);
	
	int a;
	for (a=0;a<2*100;a++,src++,mask++,dest++)
	{
		src1=*src;
		src2=*src;
		
		//src2=(src2<<shift_count)|((src2>>(16-shift_count))&mask2);
		src2=(src2<<(16-shift_count))|((src2>>shift_count)&mask2);
		
		src1&=(~(*mask));
		src2&=(*mask);
		
		*dest=src1|src2;
	}
}
//-----------------------------------------------------------------------------

void Screen_Make(void)
{
	
	Column_Make_First();
	
	int a;
	for (a=0;a<10;a++)
	{
		Column_Extract_MaskData(a,Mask_Data,col_mask);
		
		if (a)
		{
			Column_Make(col_src,col_mask,col_dest);
			memcpy(col_src,col_dest,4*100);
		}
		else
		memcpy(col_dest,col_src,4*100);
		
		Column_Display(a,col_dest);
	}
	
	memcpy(GetPlane(0),Plane0,LCD_SIZE);
	memcpy(GetPlane(1),Plane1,LCD_SIZE);
	
}
//-----------------------------------------------------------------------------

// Main Function
void _main(void)
{
	randomize();
	
	Plane0=malloc(2*LCD_SIZE);
	Plane1=Plane0+LCD_SIZE;
	
	col_src=malloc(2*100*2*3);
	col_mask=col_src+2*100;
	col_dest=col_mask+2*100;
	
	clrscr();
	FontSetSys(0);
	printf("StereoGram Maker 1.0 \n");
	printf("Programmed by Olivier Sangala \n");
	printf("http://olivier.sangala.free.fr \n");
	printf("olivier_sangala@hotmail.com \n");
	FontSetSys(1);
	ngetchx();
	
	GrayOn();
	Screen_Make();
	
	for (;;)
	{
		
		int key=ngetchx();
		
		if (key==KEY_ESC)
		break;
		if (key==KEY_F1)
		{
			source_mode^=1;
			Screen_Make();
		}
		if (key==KEY_F2)
		Screen_Make();
		
	}
	
	GrayOff();
	
	if (Plane0)
	free(Plane0);
	if (col_src)
	free(col_src);
	
}
